unit PDJSillyLabel;

// TPDJSillyLabel version 2.00
// Freeware Component for D3,D4,D5,D6
// Copyright  2000-2001 by Peric
// Birthday of Component 26.05.2001
// E-mail: pericddn@ptt.yu
// If I' find any errors or rubbish in TPDJSillyLabel please send me Your suggest or Reclamation.

{$IFDEF VER100}
  {$DEFINE PDJ_D3}
{$ELSE}
  {$IFDEF VER120}
    {$DEFINE PDJ_D4}
  {$ELSE}
    {$DEFINE PDJ_D5Up}
  {$ENDIF}
{$ENDIF}

{$IFDEF VER140}
  {$DEFINE PDJ_D6}
{$ENDIF}


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,MMSystem,Buttons,StdCtrls;

  {$R PDJSillyLabel.res}



type
  TOnMouseOverEvent = procedure(Sender: TObject) of object;
  TOnMouseOutEvent = procedure(Sender: TObject) of object;
  TPDJSillyLabel = class(TCustomControl)

  private

     FVersion: string;
     Slika:TBitmap;
     FDown:boolean;
     Captrect,R:TRect;
     x:integer;
                {$IFDEF PDJ_D3}
  {$ELSE}
    BiDiFlags: Longint ;
    {$ENDIF}
    FOnMouseOver: TOnMouseOverEvent;
    FOnMouseOut: TOnMouseOutEvent;
    Fgornja,FDonja:TPanel;
    FZadnja,FColorLine,FColorLineFocus:TColor;
    FShowHand,FUvek,FShowUpLine:boolean;
    FHintTwo: string;
    function  Muldv(a,b,c : integer) : longint;
    function  GetHintTwo: string;
    function GetVersion: string;
    procedure SetShowUpLine(value:boolean);
    procedure SetVersion(const Value: string);
    procedure SetHintTwo(AHintTwo: string);
    procedure Spektar(FR, FG, FB, DR, DG, DB : Integer);
    procedure Duga;
    procedure Cisto;
    procedure DrawCaptionEnabled;
    procedure DrawCaptionLevo;
    procedure DrawCaptionDesno;
    procedure SetUvek(value:boolean);
    procedure SetShowHand(AShowHand:boolean);
    procedure SetZadnja(value:TColor);
    procedure SetColorLine(value:TColor);
    procedure SetColorLineFocus(value:TColor);
    procedure doKliknime(Sender: TObject);
    procedure CMMouseEnter(var AMsg: TMessage);
              message CM_MOUSEENTER;
    procedure CMMouseLeave(var AMsg: TMessage);
              message CM_MOUSELEAVE;
    procedure CmEnabledChanged(var Message: TWmNoParams);
              message CM_ENABLEDCHANGED;
    procedure CmParentColorChanged(var Message: TWMNoParams);
              message CM_PARENTCOLORCHANGED;
    procedure CmTextChanged(var Message: TWmNoParams);
              message CM_TEXTCHANGED;
    procedure CmVisibleChanged(var Message: TWmNoParams);
              message CM_VISIBLECHANGED;
    procedure CmParentFontChanged(var Message: TWMNoParams);
              message CM_FONTCHANGED;
    procedure WMSetFocus(var Message: TWMSetFocus);
              message WM_SETFOCUS;
    procedure WMKillFocus(var Message: TWMKillFocus);
              message WM_KILLFOCUS;
    procedure CmDialogChar(var Message: TCMDialogChar);
              message CM_DIALOGCHAR;
    procedure WMLButtonDblClk (var Message: TWMLButtonDown);
              message WM_LBUTTONDBLCLK;
    procedure CMSysColorChange(var Message: TMessage);
              message CM_SYSCOLORCHANGE;
    procedure CMColorChanged(var Message: TMessage);
              message CM_COLORCHANGED;
    

  protected
  
    procedure Click;override;
    procedure Paint;override;
    procedure DoEnter; override;
    procedure DoExit; override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
              X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
              X, Y: Integer); override;
    procedure CreateWnd; override;
    
  public

    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

  published

    property ShowUpLine:boolean read FShowUpLine write SetShowUpLine default True;
    property AlwaysSpectrum:boolean read FUvek write SetUvek default False;
    property HintSecondLine:string read GetHintTwo  write SetHintTwo;
    property ShowHandCursor: boolean read FShowHand write SetShowHand default true;
    property Version: string read GetVersion write SetVersion;
    property ColorLine:TColor read FColorLine write SetColorLine default clBlue;
    property ColorLineFocus:TColor read FColorLineFocus write SetColorLineFocus default clLime;
    property ColorSpectrum:TColor read FZadnja write SetZadnja default clBlue;
    property Caption;
    property Font;
    property Color;
    property ParentColor;
    property Enabled;
    property Visible;
    property ShowHint;
    property DragCursor;
    property DragMode;
    property TabStop default True;
    property TabOrder;
    property OnClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseUp;
    property OnMouseMove;
    property OnStartDrag;
    property OnMouseEnter: TOnMouseOverEvent read FOnMouseOver write FOnMouseOver;
    property OnMouseExit: TOnMouseOutEvent read FOnMouseOut write FOnMouseOut;
    property OnEnter;
    property OnExit;
    property ParentFont;
    property PopupMenu;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    {$IFDEF PDJ_D5up}
    property OnContextPopup;
    {$ENDIF}
      {$IFDEF PDJ_D3}
  {$ELSE}
    property DragKind;
    property Anchors;
    property Constraints;
    property BiDiMode;
    property ParentBiDiMode;
    property OnStartDock;
    property OnEndDock;
  {$ENDIF}

  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('PDJ', [TPDJSillyLabel]);
end;

constructor TPDJSillyLabel.Create(AOwner: TComponent);
begin
inherited Create(AOwner);
SetBounds(0, 0, 105, 21);
Slika:=TBitmap.create;
TabStop:=True;
FUvek:=False;
FShowHand:=true;
FZadnja:=clBlue;
FColorLine:=clBlue;
FColorLineFocus:=clLime;
FVersion:='Version 2.00, Copyright  2000-2001 by Peric, E-mail: pericddn@ptt.yu';
FShowUpLine:=True;

 FGornja := Tpanel.Create(Self);
  with FGornja do
  begin
  ControlStyle:= ControlStyle - [csAcceptsControls];
  Caption:=' ';
  BevelOuter:=bvNone;
  Align:=alTop;
  Color:=FColorLine;
//  Height:=1;
  end;
  InsertControl(FGornja);
  FDonja := TPanel.Create(Self);
  with FDonja do
  begin
  ControlStyle:= ControlStyle - [csAcceptsControls];
  Caption:=' ';
  BevelOuter:=bvNone;
  Align:=albottom;
  Color:=FColorLine;
  Height:=1;
  end;
  InsertControl(FDonja);
end;

destructor TPDJSillyLabel.Destroy;
begin

inherited Destroy;
end;

procedure TPDJSillyLabel.CreateWnd;
begin
  inherited CreateWnd;
  if not FShowUpLine then FGornja.height:=0 else FGornja.height:=1;
end;


procedure TPDJSillyLabel.SetShowUpLine(value:boolean);
begin
if value<>FShowUpLine then
FShowUpLine:=value;
RecreateWnd;
end;

procedure TPDJSillyLabel.SetVersion(const Value: string);
begin
  FVersion:=FVersion;
end;

function TPDJSillyLabel.GetVersion: string;
begin
  Result:=FVersion;
end;



procedure TPDJSillyLabel.SetShowHand(AShowHand:boolean);
begin
fShowHand:=AShowHand;
end;

procedure TPDJSillyLabel.DoEnter;
begin
  inherited DoEnter;
end;

procedure TPDJSillyLabel.DoExit;
begin
  inherited DoExit;
end;

procedure TPDJSillyLabel.doKliknime(Sender: TObject);
begin
 if assigned(OnClick) then OnClick(Self);
end;

procedure TPDJSillyLabel.KeyDown(var Key: Word; Shift: TShiftState);
begin
  if Key = VK_RETURN then doKliknime(Self);
  inherited KeyDown(Key, Shift);
end;

procedure TPDJSillyLabel.CMDialogChar(var Message: TCMDialogChar);
begin
  with Message do
    if IsAccel(CharCode, Caption) and CanFocus then
    begin
      Click;
      Result := 1;
      SetFocus;
    end
    else
      inherited;
end;

procedure TPDJSillyLabel.WMSetFocus(var Message: TWMSetFocus);
begin
FGornja.Color:=FColorLineFocus;
FDonja.Color:=FColorLineFocus;
end;

procedure TPDJSillyLabel.WMKillFocus(var Message: TWMKillFocus);
begin
FGornja.Color:=FColorLine;
FDonja.Color:=FColorLine;
end;

procedure TPDJSillyLabel.Click;
begin
inherited
end;

function TPDJSillyLabel.Muldv(a,b,c : integer) : longint;
ASM
  MOV EAX, a
  IMUL b
  IDIV c
end;

procedure TPDJSillyLabel.SetColorLine(value:TColor);
begin
if value<> FColorLine then
begin
FColorLine:=value;
FGornja.Color:=FColorLine;
FDonja.Color:=FColorLine;
end;
end;

procedure TPDJSillyLabel.SetColorLineFocus(value:TColor);
begin
if value<> FColorLineFocus then
begin
FColorLineFocus:=value;
end;
end;

procedure TPDJSillyLabel.SetZadnja(value:TColor);
begin
if value<> FZadnja then
begin
FZadnja:=value;
invalidate;
end;
end;

procedure TPDJSillyLabel.Spektar(FR, FG, FB, DR, DG, DB : Integer);
var
  ColorRect: TRect;
  I: Integer;
  R, G, B : Byte;
  Haf : Integer;
begin
  Haf := Slika.Width Div 2;
  ColorRect.Top := 0;
  ColorRect.Bottom := Slika.Height;
  for I := 0 to Haf do begin
    ColorRect.Left := Muldv (I, Haf, Haf);
    ColorRect.Right := Muldv (I + 1, Haf, Haf);
    R := fr + Muldv(I, dr, Haf);
    G := fg + Muldv(I, dg, Haf);
    B := fb + Muldv(I, db, Haf);
    Slika.Canvas.Brush.Color := RGB(R, G, B);
    Slika.Canvas.FillRect(ColorRect);
    ColorRect.Left := Slika.Width - (Muldv (I, Haf, Haf));
    ColorRect.Right := Slika.Width - (Muldv (I + 1, Haf, Haf));
    Slika.Canvas.FillRect(ColorRect);
  end;
end;

procedure TPDJSillyLabel.Duga;
var
  FromR, FromG, FromB : Integer;
  DiffR, DiffG, DiffB : Integer;
begin
  inherited;
  Slika.Width := Width * 3 ;
  Slika.Height := Height;
  R := Rect(0,0,Width,Height);
  FromR := ColorToRGB(Color) and $000000ff;
  FromG := (ColorToRGB(Color) shr 8) and $000000ff;
  FromB := (ColorToRGB(Color) shr 16) and $000000ff;
  DiffR := (ColorToRGB(FZadnja) and $000000ff) - FromR;
  DiffG := ((ColorToRGB(FZadnja) shr 8) and $000000ff) - FromG;
  DiffB := ((ColorToRGB(FZadnja) shr 16) and $000000ff) - FromB;
  Spektar(FromR, FromG, FromB, DiffR, DiffG, DiffB);
  BitBlt(Canvas.Handle,Width div 3,0,(Width div 3)+Width * 3,Height,Slika.Canvas.Handle,0,0,SRCCOPY);
  end;

procedure TPDJSillyLabel.Paint;
begin
if csDesigning in ComponentState then  begin
Duga;
DrawCaptionLevo;
end;
if csDesigning in ComponentState then
Exit;
R := Rect(0,0,Width,Height);
if not FUvek then Cisto;
if FDown then
begin
if FUvek then Cisto;
Duga;
DrawCaptionDesno;
end
else
begin
Cisto;
if FUvek then Duga;
DrawCaptionLevo;
end;
end;

procedure TPDJSillyLabel.SetUvek(value:boolean);
begin
if FUvek<>value then
FUvek:=value;
end;

procedure TPDJSillyLabel.Cisto;
begin
with Canvas do
begin
Brush.Color:=Color;
FillRect(ClientRect);
end;
end;

procedure TPDJSillyLabel.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
inherited MouseUp(Button, Shift, X, Y);
if Button<>mbleft then exit else begin
if not enabled then exit;
FDown:=False;
Repaint;
end;
end;


procedure TPDJSillyLabel.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
Begin
inherited MouseDown(Button, Shift, X, Y);
if Button<>mbleft then exit else begin
if not enabled then exit;
FDown:=True;
Repaint;
SetFocus;
end;
end;

procedure TPDJSillyLabel.WMLButtonDblClk (var Message: TWMLButtonDown);
begin
  inherited;
  Click;
end;

procedure TPDJSillyLabel.CMMouseEnter(var AMsg: TMessage);
begin
IF FShowHand then begin
Screen.Cursors[1] := LoadCursor(hinstance,'HANDSILLY');
Cursor := 1;
end;
if Assigned(FOnMouseOver) then FOnMouseOver(Self);
end;

procedure TPDJSillyLabel.CMMouseLeave(var AMsg: TMessage);
begin
IF FShowHand then begin
Screen.Cursors[0] := crDefault;
Cursor := 0;
end;
if Assigned(FOnMouseOut) then FOnMouseOut(Self);
end;

function TPDJSillyLabel.GetHintTwo: string;
begin
     Result:=FHintTwo;
end;

procedure TPDJSillyLabel.SetHintTwo(AHintTwo:String);
begin
FHintTwo:=AHintTwo;
if csDesigning in ComponentState then
 Exit;
  if hint<>'' then
  if FHintTwo<>'' then
hint:=hint+#13+FHintTwo else
hint:=hint;
end;

procedure TPDJSillyLabel.DrawCaptionLevo;
begin
  with Canvas do
  begin
    Font := Self.Font;
    Brush.Style := bsClear;
    x:=(R.top+((R.bottom-R.top)-TextHeight(Caption)) div 2);
    CaptRect:=Rect(4,X,Width-4,X+TextHeight(Caption));
    if not Enabled then DrawCaptionEnabled;
    {$IFDEF PDJ_D3}
    DrawText(Handle, PChar(Caption), Length(Caption), CaptRect, DT_LEFT );
    {$ELSE}
    DrawText(Handle, PChar(Caption), Length(Caption), CaptRect, DT_LEFT or BiDiFlags);
    {$ENDIF}
  end;
  end;

procedure TPDJSillyLabel.DrawCaptionDesno;
begin
  with Canvas do
  begin
    Font := Self.Font;
    Brush.Style := bsClear;
    x:=(R.top+((R.bottom-R.top)-TextHeight(Caption)) div 2);
    CaptRect:=Rect(4,X,Width-8,X+TextHeight(Caption));
    {$IFDEF PDJ_D3}
    DrawText(Handle, PChar(Caption), Length(Caption), CaptRect, DT_Right );
    {$ELSE}
    DrawText(Handle, PChar(Caption), Length(Caption), CaptRect, DT_Right or BiDiFlags);
    {$ENDIF}
  end;
  end;


procedure TPDJSillyLabel.DrawCaptionEnabled;
var ECaptRect:TRect;
begin
with canvas do
  begin
     Font := Self.Font;
     brush.style:=bsClear;
     font.Color :=clBtnHighlight;
     
     ECaptRect:=Rect(CaptRect.Left+1,CaptRect.top+1,CaptRect.Right+1,CaptRect.Bottom+1);
     {$IFDEF PDJ_D3}
     DrawText(Handle, PChar(Caption), Length(Caption), ECaptRect, DT_LEFT );
     {$ELSE}
     DrawText(Handle, PChar(Caption), Length(Caption), ECaptRect, DT_LEFT or BiDiFlags);
     {$ENDIF}
     font.color :=clBtnShadow;
  end;
end;

procedure TPDJSillyLabel.CMColorChanged(var Message: TMessage);
begin
  inherited;
  Invalidate;
end;

procedure TPDJSillyLabel.CMSysColorChange(var Message: TMessage);
begin
  inherited;
  Invalidate;
end;

procedure TPDJSillyLabel.CmParentFontChanged(var Message: TWMNoParams);
begin
  inherited;
  Invalidate;
end;

procedure TPDJSillyLabel.CmTextChanged(var Message: TWmNoParams);
begin
  inherited;
  Invalidate;
end;

procedure TPDJSillyLabel.CmVisibleChanged(var Message: TWmNoParams);
begin
  inherited;
  Invalidate;
end;

procedure TPDJSillyLabel.CmParentColorChanged(var Message: TWMNoParams);
begin
  inherited;
  Invalidate;
end;

procedure TPDJSillyLabel.CmEnabledChanged(var Message: TWmNoParams);
begin
  inherited;
  Invalidate;
end;




end.
